/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of TIPC.xs. Do not edit this file, edit TIPC.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "TIPC.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "tipc.h"

#ifndef PF_TIPC
# ifdef AF_TIPC
#  define PF_TIPC AF_TIPC
# endif
#endif

/* We toss these around a LOT.  Use a typedef, to keep it concise. */
typedef struct sockaddr_tipc SAT;

/* input-checking for passing a struct sockaddr_tipc from within an SvRV*. */
SAT *_tipc_sanity_check(SV *rv) {
	SV *sv;
	if(SvTYPE(rv) == SVt_RV)
		sv = SvRV(rv);
	else
		croak("Sockaddr methods work on blessed references to raw data.");
	if(sv_len(sv) != 16)
		croak("Sockaddr method called with non-sockaddr argument! (length is %i)",sv_len(sv));
	else {
		SAT *sat = (void*)SvPV_nolen(sv);
		if(sat->family != AF_TIPC)
			croak("Sockaddr family mismatch: not AF_TIPC!");
		return sat;
	}
	return NULL;
}

/* in the following code, internal functions are prefixed with "_tipc_".
 * Stuff intended for direct user use does not have this prefix. */

#include "const-c.inc"

#line 51 "TIPC.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 195 "TIPC.c"

/* INCLUDE:  Including 'const-xs.inc' from 'TIPC.xs' */


XS_EUPXS(XS_IO__Socket__TIPC_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 220 "TIPC.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid IO::Socket::TIPC macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined IO::Socket::TIPC macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing IO::Socket::TIPC macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 298 "TIPC.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'TIPC.xs' from 'const-xs.inc' */


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_create)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 73 "TIPC.xs"
	SAT sat;
	SV *sv, *rv;
#line 319 "TIPC.c"
#line 76 "TIPC.xs"
	memset(&sat,0,sizeof(sat));
	sat.family = AF_TIPC;
	rv = newSV(0);
	sv = newSVrv(rv,"IO::Socket::TIPC::Sockaddr");
	sv_setpvn(sv, (void*)&sat, sizeof(sat));
	RETVAL = rv;
#line 327 "TIPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 93 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 346 "TIPC.c"
#line 95 "TIPC.xs"
	memset(sat,0,sizeof(SAT));
	sat->family = AF_TIPC;
#line 350 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_common); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_common)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, scope");
    {
	SV *	sv = ST(0)
;
	I8	scope = (I8)SvIV(ST(1))
;
#line 113 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 371 "TIPC.c"
#line 115 "TIPC.xs"
	sat->family   = AF_TIPC;
	sat->scope    = scope;
#line 375 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sv, ref, node");
    {
	SV *	sv = ST(0)
;
	unsigned int	ref = (unsigned int)SvUV(ST(1))
;
	unsigned int	node = (unsigned int)SvUV(ST(2))
;
#line 133 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 398 "TIPC.c"
#line 135 "TIPC.xs"
	sat->addrtype     = TIPC_ADDR_ID;
	sat->addr.id.ref  = ref;
	sat->addr.id.node = node;
#line 403 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id_pieces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id_pieces)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "sv, ref, zone, cluster, node");
    {
	SV *	sv = ST(0)
;
	unsigned int	ref = (unsigned int)SvUV(ST(1))
;
	unsigned int	zone = (unsigned int)SvUV(ST(2))
;
	unsigned int	cluster = (unsigned int)SvUV(ST(3))
;
	unsigned int	node = (unsigned int)SvUV(ST(4))
;
#line 156 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 430 "TIPC.c"
#line 158 "TIPC.xs"
	sat->addrtype     = TIPC_ADDR_ID;
	sat->addr.id.ref  = ref;
	sat->addr.id.node = tipc_addr(zone, cluster, node);
#line 435 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_name)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "sv, type, instance, domain");
    {
	SV *	sv = ST(0)
;
	unsigned int	type = (unsigned int)SvUV(ST(1))
;
	unsigned int	instance = (unsigned int)SvUV(ST(2))
;
	unsigned int	domain = (unsigned int)SvUV(ST(3))
;
#line 178 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 460 "TIPC.c"
#line 180 "TIPC.xs"
	sat->addrtype                = TIPC_ADDR_NAME;
	sat->addr.name.name.type     = type;
	sat->addr.name.name.instance = instance;
	sat->addr.name.domain        = domain;
#line 466 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_nameseq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_fill_nameseq)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "sv, type, lower, upper");
    {
	SV *	sv = ST(0)
;
	unsigned int	type = (unsigned int)SvUV(ST(1))
;
	unsigned int	lower = (unsigned int)SvUV(ST(2))
;
	unsigned int	upper = (unsigned int)SvUV(ST(3))
;
#line 202 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 491 "TIPC.c"
#line 204 "TIPC.xs"
	sat->addrtype           = TIPC_ADDR_NAMESEQ;
	sat->addr.nameseq.type  = type;
	sat->addr.nameseq.lower = lower;
	sat->addr.nameseq.upper = upper;
#line 497 "TIPC.c"
	ST(0) = sv;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_stringify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_stringify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	SV *	RETVAL;
#line 221 "TIPC.xs"
	struct node_addr;
	SAT *sat = _tipc_sanity_check(sv);
#line 518 "TIPC.c"
#line 224 "TIPC.xs"
	/* _tipc_sanity_check already checked AF_INET for us. */
	switch(sat->addrtype) {
	  case 0:
		RETVAL = newSVpvf("(uninitialized addrtype)");
		break;
	  case TIPC_ADDR_ID: /* by TIPC address and ref-id */
		RETVAL = newSVpvf("<%u.%u.%u:%u>",tipc_zone(sat->addr.id.node),
			tipc_cluster(sat->addr.id.node),tipc_node(sat->addr.id.node),
			sat->addr.id.ref);
		break;
	  case TIPC_ADDR_NAME: /* by name (NOTE: "domain" isn't shown) */
		RETVAL = newSVpvf("{%u, %u}",sat->addr.name.name.type,
			sat->addr.name.name.instance);
		break;
	  case TIPC_ADDR_NAMESEQ: /* multicast name range */
		RETVAL = newSVpvf("{%u, %u, %u}",sat->addr.nameseq.type,
			sat->addr.nameseq.lower,sat->addr.nameseq.upper);
		break;
	  default:
		RETVAL = newSVpvf("(invalid addrtype)");
		break;
	}
#line 542 "TIPC.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_family); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_family)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U16	RETVAL;
	dXSTARG;
#line 265 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 563 "TIPC.c"
#line 267 "TIPC.xs"
	RETVAL = sat->family;
#line 566 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_addrtype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_addrtype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U8	RETVAL;
	dXSTARG;
#line 275 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 586 "TIPC.c"
#line 277 "TIPC.xs"
	RETVAL = sat->addrtype;
#line 589 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_scope); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_scope)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	I8	RETVAL;
	dXSTARG;
#line 285 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 609 "TIPC.c"
#line 287 "TIPC.xs"
	RETVAL = sat->scope;
#line 612 "TIPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_ref)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 295 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 632 "TIPC.c"
#line 297 "TIPC.xs"
	RETVAL = sat->addr.id.ref;
#line 635 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 305 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 655 "TIPC.c"
#line 307 "TIPC.xs"
	RETVAL = sat->addr.id.node;
#line 658 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_zone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_zone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 315 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 678 "TIPC.c"
#line 317 "TIPC.xs"
	RETVAL = tipc_zone(sat->addr.id.node);
#line 681 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_cluster); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_cluster)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 325 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 701 "TIPC.c"
#line 327 "TIPC.xs"
	RETVAL = tipc_cluster(sat->addr.id.node);
#line 704 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_node)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 335 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 724 "TIPC.c"
#line 337 "TIPC.xs"
	RETVAL = tipc_node(sat->addr.id.node);
#line 727 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_ntype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_ntype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 345 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 747 "TIPC.c"
#line 347 "TIPC.xs"
	RETVAL = sat->addr.name.name.type;
#line 750 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_instance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_instance)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 355 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 770 "TIPC.c"
#line 357 "TIPC.xs"
	RETVAL = sat->addr.name.name.instance;
#line 773 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_domain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_domain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 365 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 793 "TIPC.c"
#line 367 "TIPC.xs"
	RETVAL = sat->addr.name.domain;
#line 796 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_stype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_stype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 375 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 816 "TIPC.c"
#line 377 "TIPC.xs"
	RETVAL = sat->addr.nameseq.type;
#line 819 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_lower); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_lower)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 385 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 839 "TIPC.c"
#line 387 "TIPC.xs"
	RETVAL = sat->addr.nameseq.lower;
#line 842 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_upper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_upper)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 395 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 862 "TIPC.c"
#line 397 "TIPC.xs"
	RETVAL = sat->addr.nameseq.upper;
#line 865 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_addrtype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_addrtype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U8	arg = (U8)SvUV(ST(1))
;
	U8	RETVAL;
	dXSTARG;
#line 413 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 887 "TIPC.c"
#line 415 "TIPC.xs"
	RETVAL = sat->addrtype = arg;
#line 890 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_scope); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_scope)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	I8	arg = (I8)SvIV(ST(1))
;
	I8	RETVAL;
	dXSTARG;
#line 424 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 912 "TIPC.c"
#line 426 "TIPC.xs"
	RETVAL = sat->scope = arg;
#line 915 "TIPC.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_ref)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 435 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 937 "TIPC.c"
#line 437 "TIPC.xs"
	RETVAL = sat->addr.id.ref = arg;
#line 940 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_set_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_set_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 446 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 962 "TIPC.c"
#line 448 "TIPC.xs"
	RETVAL = sat->addr.id.node = arg;
#line 965 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_zone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_zone)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 457 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 987 "TIPC.c"
#line 459 "TIPC.xs"
	sat->addr.id.node = tipc_addr(arg,tipc_cluster(sat->addr.id.node),tipc_node(sat->addr.id.node));
	RETVAL = arg;
#line 991 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_cluster); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_cluster)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 469 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1013 "TIPC.c"
#line 471 "TIPC.xs"
	sat->addr.id.node = tipc_addr(tipc_zone(sat->addr.id.node),arg,tipc_node(sat->addr.id.node));
	RETVAL = arg;
#line 1017 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_node)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 481 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1039 "TIPC.c"
#line 483 "TIPC.xs"
	sat->addr.id.node = tipc_addr(tipc_zone(sat->addr.id.node),tipc_cluster(sat->addr.id.node),arg);
	RETVAL = arg;
#line 1043 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_ntype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_ntype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 493 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1065 "TIPC.c"
#line 495 "TIPC.xs"
	RETVAL = sat->addr.name.name.type = arg;
#line 1068 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_instance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_instance)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 504 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1090 "TIPC.c"
#line 506 "TIPC.xs"
	RETVAL = sat->addr.name.name.instance = arg;
#line 1093 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_set_domain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_set_domain)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 515 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1115 "TIPC.c"
#line 517 "TIPC.xs"
	RETVAL = sat->addr.name.domain = arg;
#line 1118 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_stype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_stype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 526 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1140 "TIPC.c"
#line 528 "TIPC.xs"
	RETVAL = sat->addr.nameseq.type = arg;
#line 1143 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_lower); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_lower)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 537 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1165 "TIPC.c"
#line 539 "TIPC.xs"
	RETVAL = sat->addr.nameseq.lower = arg;
#line 1168 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_upper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_upper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U32	arg = (unsigned long)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 548 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1190 "TIPC.c"
#line 550 "TIPC.xs"
	RETVAL = sat->addr.nameseq.upper = arg;
#line 1193 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 563 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1213 "TIPC.c"
#line 565 "TIPC.xs"
	switch(sat->addrtype) {
		case TIPC_ADDR_NAME:
			RETVAL = sat->addr.name.name.type;
			break;
		case TIPC_ADDR_NAMESEQ:
			RETVAL = sat->addr.nameseq.type;
			break;
		default:
			croak("get_type() called for a typeless sockaddr.");
	}
#line 1225 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr_set_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
	SV *	sv = ST(0)
;
	U8	arg = (U8)SvUV(ST(1))
;
	U32	RETVAL;
	dXSTARG;
#line 583 "TIPC.xs"
	SAT *sat = _tipc_sanity_check(sv);
#line 1247 "TIPC.c"
#line 585 "TIPC.xs"
	switch(sat->addrtype) {
		case TIPC_ADDR_NAME:
			RETVAL = sat->addr.name.name.type = arg;
			break;
		case TIPC_ADDR_NAMESEQ:
			RETVAL = sat->addr.nameseq.type = arg;
			break;
		default:
			croak("set_type() called for a typeless sockaddr.");
	}
#line 1259 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_addr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "zone, cluster, node");
    {
	U32	zone = (unsigned long)SvUV(ST(0))
;
	U32	cluster = (unsigned long)SvUV(ST(1))
;
	U32	node = (unsigned long)SvUV(ST(2))
;
	U32	RETVAL;
	dXSTARG;
#line 607 "TIPC.xs"
	RETVAL = tipc_addr(zone, cluster, node);
#line 1283 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_zone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_zone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "addr");
    {
	U32	addr = (unsigned long)SvUV(ST(0))
;
	U32	RETVAL;
	dXSTARG;
#line 615 "TIPC.xs"
	RETVAL = tipc_zone(addr);
#line 1303 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_cluster); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_cluster)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "addr");
    {
	U32	addr = (unsigned long)SvUV(ST(0))
;
	U32	RETVAL;
	dXSTARG;
#line 623 "TIPC.xs"
	RETVAL = tipc_cluster(addr);
#line 1323 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_node); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr__tipc_node)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "addr");
    {
	U32	addr = (unsigned long)SvUV(ST(0))
;
	U32	RETVAL;
	dXSTARG;
#line 631 "TIPC.xs"
	RETVAL = tipc_node(addr);
#line 1343 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr___leak_a_scalar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__Socket__TIPC__Sockaddr___leak_a_scalar)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	U32	RETVAL;
	dXSTARG;
#line 644 "TIPC.xs"
	RETVAL = newSVpvf("leaky leak") ? 1 : 0;
#line 1363 "TIPC.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_IO__Socket__TIPC); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_IO__Socket__TIPC)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("IO::Socket::TIPC::constant", XS_IO__Socket__TIPC_constant);
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_create", XS_IO__Socket__TIPC__Sockaddr__tipc_create, file, "");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_clear", XS_IO__Socket__TIPC__Sockaddr__tipc_clear, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_fill_common", XS_IO__Socket__TIPC__Sockaddr__tipc_fill_common, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_fill_id", XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id, file, "$$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_fill_id_pieces", XS_IO__Socket__TIPC__Sockaddr__tipc_fill_id_pieces, file, "$$$$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_fill_name", XS_IO__Socket__TIPC__Sockaddr__tipc_fill_name, file, "$$$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_fill_nameseq", XS_IO__Socket__TIPC__Sockaddr__tipc_fill_nameseq, file, "$$$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::stringify", XS_IO__Socket__TIPC__Sockaddr_stringify, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_family", XS_IO__Socket__TIPC__Sockaddr_get_family, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_addrtype", XS_IO__Socket__TIPC__Sockaddr_get_addrtype, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_scope", XS_IO__Socket__TIPC__Sockaddr_get_scope, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_ref", XS_IO__Socket__TIPC__Sockaddr_get_ref, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_id", XS_IO__Socket__TIPC__Sockaddr_get_id, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_zone", XS_IO__Socket__TIPC__Sockaddr_get_zone, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_cluster", XS_IO__Socket__TIPC__Sockaddr_get_cluster, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_node", XS_IO__Socket__TIPC__Sockaddr_get_node, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_ntype", XS_IO__Socket__TIPC__Sockaddr_get_ntype, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_instance", XS_IO__Socket__TIPC__Sockaddr_get_instance, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_domain", XS_IO__Socket__TIPC__Sockaddr_get_domain, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_stype", XS_IO__Socket__TIPC__Sockaddr_get_stype, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_lower", XS_IO__Socket__TIPC__Sockaddr_get_lower, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_upper", XS_IO__Socket__TIPC__Sockaddr_get_upper, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_addrtype", XS_IO__Socket__TIPC__Sockaddr_set_addrtype, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_scope", XS_IO__Socket__TIPC__Sockaddr_set_scope, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_ref", XS_IO__Socket__TIPC__Sockaddr_set_ref, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_set_id", XS_IO__Socket__TIPC__Sockaddr__tipc_set_id, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_zone", XS_IO__Socket__TIPC__Sockaddr_set_zone, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_cluster", XS_IO__Socket__TIPC__Sockaddr_set_cluster, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_node", XS_IO__Socket__TIPC__Sockaddr_set_node, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_ntype", XS_IO__Socket__TIPC__Sockaddr_set_ntype, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_instance", XS_IO__Socket__TIPC__Sockaddr_set_instance, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_set_domain", XS_IO__Socket__TIPC__Sockaddr__tipc_set_domain, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_stype", XS_IO__Socket__TIPC__Sockaddr_set_stype, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_lower", XS_IO__Socket__TIPC__Sockaddr_set_lower, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_upper", XS_IO__Socket__TIPC__Sockaddr_set_upper, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::get_type", XS_IO__Socket__TIPC__Sockaddr_get_type, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::set_type", XS_IO__Socket__TIPC__Sockaddr_set_type, file, "$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_addr", XS_IO__Socket__TIPC__Sockaddr__tipc_addr, file, "$$$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_zone", XS_IO__Socket__TIPC__Sockaddr__tipc_zone, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_cluster", XS_IO__Socket__TIPC__Sockaddr__tipc_cluster, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::_tipc_node", XS_IO__Socket__TIPC__Sockaddr__tipc_node, file, "$");
        (void)newXSproto_portable("IO::Socket::TIPC::Sockaddr::__leak_a_scalar", XS_IO__Socket__TIPC__Sockaddr___leak_a_scalar, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

